/*

*/

import renderer.scene.*;
import renderer.pipeline.*;
import renderer.framebuffer.*;

import java.awt.Color;

/**

*/
public class ThreeOverlappingTriangles
{
   public static void main(String[] args)
   {
      // Create the Scene object that we shall render.
      Scene scene = new Scene();
      scene.camera.projPerspective(-2, 2, -2, 2, 1);
      scene.camera.viewTranslate(0, 0, 1);

      // Create a Model object to hold the geometry.
      Model model = new Model();

      double z = -0.0001;

      // Add the geometry (in model coordinates) to the Model.
      Vertex v0 = new Vertex(-1,  1,  -1);  // red
      Vertex v1 = new Vertex(-2,  0,  -1);
      Vertex v2 = new Vertex( 2, -1,   0);

      Vertex v3 = new Vertex( 2,  1,  -1);  // green
      Vertex v4 = new Vertex( 2,  2,  -1);
      Vertex v5 = new Vertex(-1, -1,   0);

      Vertex v6 = new Vertex(1, -2,  -1);  // blue
      Vertex v7 = new Vertex(2, -2,  -1);
      Vertex v8 = new Vertex(1,  2,   0);

      v0.setColor(Color.red);
      v1.setColor(Color.red);
      v2.setColor(Color.red);
      v3.setColor(Color.green);
      v4.setColor(Color.green);
      v5.setColor(Color.green);
      v6.setColor(Color.blue);
      v7.setColor(Color.blue);
      v8.setColor(Color.blue);

      model.addTriangle(v0, v1, v2);
      model.addTriangle(v3, v4, v5);
      model.addTriangle(v6, v7, v8);

      // Add the Model to the Scene.
      scene.addPosition(new Position(model));

      // Create a FrameBuffer to render our scene into.
      int width  = 512;
      int height = 512;
      FrameBuffer fb = new FrameBuffer(width, height);

      // Give the framebuffer a background color.
      fb.clearFB(java.awt.Color.darkGray);
      // Render our scene into the frame buffer using a Perspective Projection.
      Pipeline.debug = true;
      //Rasterize.debug = true;
      Pipeline.render(scene, fb);
      // Save the resulting image in a file.
      fb.dumpFB2File( "ThreeOverlappingTriangles.ppm" );
   }
}
